(* tools for arithmetic
   WN.8.3.01

   remove_thy"Atools";
   use_thy_only"knowledge/Atools";
   use_thy"knowledge/Atools";
   use_thy"knowledge/Isac";


   use"ROOT.ML";
   cd"knowledge";
*)


Atools = Complex + Descript +

(*-------------------- consts------------------------------------------------*)
consts

  Arbfix, Undef    :: real
  dummy            :: real

  occurs'_in :: "[real, real] => bool" ("_ occurs'_in _")

 "pow"   :: [real, real] => real    (infixr "^^^" 80)
(* ~~~ power doesn't allow Free("2",real) ^ Free("2",nat)
                           ~~~~     ~~~~    ~~~~     ~~~*)
  "abs"   :: real => real            ("(|| _ ||)")
(* ~~~ FIXXXME Isabelle2002 has abs already !!!*)
  "absset":: real set => real        ("(||| _ |||)")
  (*is numeral constant ?*)
  "is'_const" :: real => bool        ("_ is'_const" 10)
  "is'_atom"  :: real => bool        ("_ is'_atom" 10)
  "is'_even"  :: real => bool        ("_ is'_even" 10)
			
  (* identity on term level*)
  "ident"     :: ['a, 'a] => bool    ("(_ =!=/ _)" [51, 51] 50)



(*-------------------- rules------------------------------------------------*)
rules (*for evaluating the assumptions of conditional rules*)

  real_unari_minus           "- a = (-1) * a"

  rle_refl                  "(n::real) <= n"
(*reflI                     "(t = t) = True"*)
  radd_left_cancel_le       "((k::real) + m <= k + n) = (m <= n)"
  not_true                  "(~ True) = False"
  not_false                 "(~ False) = True"
  and_true                  "(a & True) = a"
  and_false                 "(a & False) = False"
  or_true                   "(a | True) = True"
  or_false                  "(a | False) = a"
  and_commute               "(a & b) = (b & a)"
  or_commute                "(a | b) = (b | a)"

end
