(* tools for differentiation
   WN.11.99
   use"../knowledge/Diff.ML";
   use"knowledge/Diff.ML";
   use"Diff.ML";
 *)


(** interface isabelle -- isac **)

theory' := overwritel (!theory', [("Diff.thy",Diff.thy)]);

theorem' := overwritel (!theorem',
[("diff_const",num_str diff_const),
 ("diff_prod_const",num_str diff_prod_const),
 ("diff_var",num_str diff_var),
 ("diff_sum",num_str diff_sum),
 ("diff_quot",num_str diff_quot),
 ("diff_sin",num_str diff_sin),
 ("diff_sin_chain",num_str diff_sin_chain),
 ("diff_cos",num_str diff_cos),
 ("diff_cos_chain",num_str diff_cos_chain),
 ("diff_pow",num_str diff_pow),
 ("diff_pow_chain",num_str diff_pow_chain),
 ("diff_ln",num_str diff_ln),
 ("diff_ln_chain",num_str diff_ln_chain),
 ("diff_exp",num_str diff_exp),
 ("diff_exp_chain",num_str diff_exp_chain),
 ("diff_sqrt",num_str diff_sqrt),
 ("diff_sqrt_chain",num_str diff_sqrt_chain)
]);


(** problem types **)

store_pbt
 (prep_pbt Diff.thy
 (["function"],
  [("#Given" ,["functionTerm f_","differentiateFor v_"]),
   ("#Find"  ,["derivative f_'_"])
  ],
  append_rls "e_rls" e_rls [], None, []));

store_pbt
 (prep_pbt Diff.thy
 (["derivative_of","function"],
  [("#Given" ,["functionTerm f_","differentiateFor v_"]),
   ("#Find"  ,["derivative f_'_"])
  ],
  append_rls "e_rls" e_rls [], None, []));


(** methods **)

methods:= overwritel (!methods,
[
 prep_met 
 (("Diff.thy","differentiate_on_R"),
   [("#Given" ,["functionTerm f_","differentiateFor v_"]),
    ("#Find"  ,["derivative f_'_"])
    ],
   {rew_ord'="tless_true",rls'=atools_erls,calc = [], srls = e_rls, prls=e_rls,
    asm_rls=[],asm_thm=[("diff_quot","")]},
 "Script Differentiate (f_::real) (v_::real) =                \
 \((Try (Repeat (Rewrite frac_conv   False))) @@       \
 \ (Try (Repeat (Rewrite root_conv   False))) @@       \
 \ (Try (Repeat (Rewrite realpow_pow False))) @@      \
 \ (Repeat                                           \
 \   ((Repeat (Rewrite_Inst [(bdv,v_)] diff_sum        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod_const False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_quot       True )) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln         False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln_chain   False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt_chain False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_const      False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_var        False)) Or \
 \    (Repeat (Rewrite_Set             make_polynomial False)))) @@ \
 \ (Try (Repeat (Rewrite sym_frac_conv False))) @@              \
 \ (Try (Repeat (Rewrite sym_root_conv False)))) (f_::real)"
 )
,
 prep_met 
 (("Diff.thy","diff_simpl"),
   [("#Given" ,["functionTerm f_","differentiateFor v_"]),
    ("#Find"  ,["derivative f_'_"])
    ],
   {rew_ord'="tless_true",rls'=atools_erls, calc = [], srls = e_rls,prls=e_rls,
    asm_rls=[],asm_thm=[("diff_quot","")]},
 "Script Differentiate (f_::real) (v_::real) =                \
 \(Repeat                                           \
 \   ((Repeat (Rewrite_Inst [(bdv,v_)] diff_sum        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod_const False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_quot       True )) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln         False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln_chain   False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt_chain False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_const      False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_var        False)) Or \
 \    (Repeat (Rewrite_Set             make_polynomial False)))) \
 \ (f_::real)"
 )
]);
